#! /usr/bin/env python
# -.- coding: utf-8 -.-
#
# Sezen
#
# Copyright © 2009-2010 Seif Lotfy <seif@lotfy.com>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

import gtk
from view.widgets import Window
from model.datasink import DataSink
import sys
import gnomeapplet

def factory(applet, iid):
	"""
	menu_item = gtk.MenuItem("Library")
	#panel = menu_item.get_toplevel().window
	#panel_x, panel_y = panel.get_origin()
	#panel_width, panel_height = panel.get_size()
	menu_bar = gtk.MenuBar()
	#button.connect("button_press_event", showMenu, applet)
	menu_bar.set_pack_direction(gtk.PACK_DIRECTION_TTB)
	menu_bar.append(menu_item)
	applet.add(menu_bar)
	applet.show_all()
	return True
	"""
	button = gtk.ImageMenuItem("Library")
	button_icon = gtk.image_new_from_icon_name('distributor-logo', gtk.ICON_SIZE_SMALL_TOOLBAR)
	button.set_image(button_icon)

	menu = gtk.MenuBar()
	menu.add(button)
	
	applet.add(menu)
	applet.show_all()
	
	
	panel = applet.get_toplevel().window
	panel_width, panel_height = panel.get_size()
	applet_x, applet_y, applet_width, applet_height = button.get_allocation()
	menu.set_size_request(-1, 32)
	
	return True

def showMenu(widget, event, applet):
	if event.type == gtk.gdk.BUTTON_PRESS and event.button == 3:
		widget.emit_stop_by_name("button_press_event")
		create_menu(applet)

def create_menu(applet):
	propxml="""
			<popup name="button3">
			<menuitem name="Item 3" verb="About" label="_About" pixtype="stock" pixname="gtk-about"/>
			</popup>"""
	verbs = [("About", showAboutDialog)]
	applet.setup_menu(propxml, verbs, None)

def showAboutDialog(*arguments, **keywords):
	pass

if len(sys.argv) == 2:
	if sys.argv[1] == "run-in-window":
		mainWindow = gtk.Window(gtk.WINDOW_TOPLEVEL)
		mainWindow.set_title("Ubuntu System Panel")
		mainWindow.connect("destroy", gtk.main_quit)
		applet = gnomeapplet.Applet()
		applet.reparent(mainWindow)
		factory(applet, None)
		mainWindow.show_all()
		gtk.main()
		sys.exit()

if __name__ == '__main__':
	#print "Starting factory"
	#gnomeapplet.bonobo_factory("OAFIID:Gnome_Panel_Example_Factory", gnomeapplet.Applet.__gtype__, "Simple gnome applet example", "1.0", factory)

	view = Window()
	datasink = DataSink()
	view.set_model(datasink)
	#datasink.load_events()
	gtk.main()
